// --------------------------------------------------------------------
// >>>>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<
// --------------------------------------------------------------------
// Module: pianoshield_top
// 
// Author: Step
// 
// Description: pianoshield top module
//	
// Web: www.stepfpga.com
// 
// --------------------------------------------------------------------
// Code Revision History :
// --------------------------------------------------------------------
// Version: |Mod. Date:   |Changes Made:
// V1.0     |2017/06/5   |Initial ver
// --------------------------------------------------------------------
module pianoshield_top(
	input				clk_in,			//ⲿʱ룬STEP FPGAC1
	input				rst_n_in,		//ϵͳλӦSTEP FPGA尴L14
	output				scl_out,		//I2C SCLSTEP FPGAC8
	inout				sda_out,		//I2C SDASTEP FPGAB8
	output 				beepout,		//ӦpianoshieldطF14
	output	[7:0]		led_out,		//ӦSTEP FPGA8LED
	output 	[8:0] 		segment_led_1,  //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
	output 	[8:0] 		segment_led_2   //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
);

//cap1188ĶӦֵ,ÿcap11888·Ӧ8:8'h01,8'h04,8'h10,8'h20,8'h40,8'h80ûаʱ0
wire 	[7:0]	sensor_data1,sensor_data2;
reg 	[7:0]	tone=0;			//pianoģʽݴֵӦƵ

//cap1188_i2cģͨI2CCAP1188ͨţǰֵ
cap1188_i2c		cap1188_i2c_u
(
	.clk_in					(clk_in		 ),
	.rst_n_in				(rst_n_in	 ),
	.scl_out				(scl_out	 ),
	.sda_out				(sda_out	 ),
	.sensor_data1			(sensor_data1),
	.sensor_data2			(sensor_data2)
);

//pianosheldҲܼ MODE/up/down
reg 			down_button=0;	//up_button/down_buttonmusicboxģʽлһ׺һ
reg 			up_button=0;
reg 			mode_button=0; 	//mode_buttonлpianoģʽģʽ

//alwaysУݴֵsensor_data1sensor_data2ӦĹ
//sensor_data18ֵsensor_data2ǰ5ֵӦ13sensor_data2ĺֵΪܼ
always@(posedge clk_in or negedge rst_n_in) 
begin
	if(!rst_n_in) begin
		tone <= 0;
		down_button <= 0;
		up_button <= 0;
		mode_button <= 0;
	end else begin	
		if(sensor_data1) begin
			tone <= sensor_data1;
		end else if(sensor_data2)begin
			case(sensor_data2)
				8'h20 :  down_button <= 1;
				8'h40 :  up_button <= 1;	
				8'h80 :  mode_button <= 1;		
				default: begin tone <= ~sensor_data2;end //Ƭcap1188ΪһƬֵڶƬֵλȡ
			endcase
		end else begin
				tone <= 0;
				down_button <= 0;
				up_button <= 0;
				mode_button <= 0;
		end
	end
end

wire	tone_en;	//ģʽ·ģʹźţ1Ч
wire	piano_out;	//Ƶ
//
assign tone_en = (tone==0)?1'b0:1'b1;	//toneΪ0ʱҲǴֵ0ʱʾûа£ر

//beeperģΪģʽ·ģ
beeper 			beeper_u
(
	.clk_in					(clk_in			),
	.rst_n_in				(rst_n_in		),
	.tone_en				(tone_en		),
	.tone					(tone			),
	.piano_out				(piano_out		)
);

wire 	[7:0] 	freq_index_out;	//music boxģʽµǰŵţLEDƣԵÿ
wire 	[2:0] 	button_pulse;	//ܼźţʱһʱӵĸߵƽ壬ư
wire 	[2:0] 	button_in;		
reg 	[2:0] 	button_status_r,button_status;

//ܼź
assign button_in = {mode_button,up_button,down_button};

always@( posedge clk_in  or  negedge rst_n_in )
	if (!rst_n_in) begin button_status_r <= 3'b111;button_status <= 3'b111; end
    else  begin button_status <= button_in;button_status_r <= button_status;end
		
//ʱһʱӵĸߵƽ壬ư
assign button_pulse = button_status & ( ~button_status_r);

//music boxģ鲥ģʽڴģҪŵ
music_box 	musicbox_u(
	.clk_in				(clk_in		   ),
	.rst_n_in			(rst_n_in      ),
	.button_status		(button_pulse  ),
	.speaker			(speaker_mb    ),
	.freq_index_out 	(freq_index_out)
	);
	
reg		mode_flag=0;	//ģʽѡ

//MODEܼѡǰĹģʽǵ໹ǲ
always@(posedge clk_in or negedge rst_n_in) 
	begin
		if(!rst_n_in) begin
			mode_flag <= 0;
		end else begin
			if(button_pulse[2])
				mode_flag <= !mode_flag;
		end
	end
//ģʽѡźԴmusic boxpiano
assign beepout = mode_flag ? speaker_mb : piano_out;
//ģʽѡLEDԴmusic boxpiano
assign led_out = mode_flag ? freq_index_out : tone ;	
//ģʾǰֵ
display		display_u
(	.rst_n_in(rst_n_in),
	.sensor_data_1(sensor_data1),  //seg_data input
	.sensor_data_2(sensor_data2),  //seg_data input
	.segment_led_1(segment_led_1),  //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
	.segment_led_2(segment_led_2)   //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
);

endmodule
